package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.PricingEspecificoCategoriaDAO;
import com.rjconsultores.ventaboletos.entidad.PricingEspecificoCategoria;

@Repository("pricingEspecificoCategoriaDAO")
public class PricingEspecificoCategoriaHibernateDAO extends GenericHibernateDAO<PricingEspecificoCategoria, Long> implements PricingEspecificoCategoriaDAO {

	@Autowired
	public PricingEspecificoCategoriaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<PricingEspecificoCategoria> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	@Override
	public Boolean isDuplicado(PricingEspecificoCategoria entidad) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("categoria.categoriaId", entidad.getCategoria().getCategoriaId()));

		return c.list().isEmpty();
	}
}
